<?php
/**
 * Created by PhpStorm.
 * User: gustavolima
 * Date: 14/09/2015
 * Time: 14:59
 */

namespace Teknisa\CRM\Service;
use Doctrine\ORM\EntityManager;


class crm00038001DesempenhoOperadorService {

    /** @var  EntityManager */
    protected $entityManager;
    /** @var  Environment */
    protected $environment;

    public function __construct($entityManager, $environment) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
    }

    public function getRowsByFilter(array $filterValues)
    {
        $where = "";
        foreach($filterValues as $valuesToFilter)
        {
            $where .= " AND EXEC.".$valuesToFilter['columnName']." = '".$valuesToFilter['value']."'";
        }

        $sql = "SELECT SUM(NVL(QTDEBOM, 0))
                AS
                  QTDEBOM, SUM(NVL(QTDERUIM, 0))
                AS
                  QTDERUIM, SUM(NVL(QTDEOTIMO, 0))
                AS
                  QTDEOTIMO, SUM(NVL(QTDEREGULAR, 0))
                AS
                  QTDEREGULAR, NMPRINCIPALPARC FROM
                  (SELECT
                    CASE
                      WHEN RESAVAL.TXRESPAVALIACAO = 'Bom'
                      THEN COUNT(*)
                    END QTDEBOM,
                    CASE
                      WHEN RESAVAL.TXRESPAVALIACAO = 'Ruim'
                      THEN COUNT(*)
                    END QTDERUIM,
                    CASE
                      WHEN RESAVAL.TXRESPAVALIACAO = 'Ótimo'
                      THEN COUNT(*)
                    END QTDEOTIMO,
                    CASE
                      WHEN RESAVAL.TXRESPAVALIACAO = 'Regular'
                      THEN COUNT(*)
                    END QTDEREGULAR,
                    PA.NMPRINCIPALPARC
                  FROM RESPAVALIACAO RESAVAL
                  LEFT JOIN EXECAVALIACAO EXEC
                  ON EXEC.NREXECAVALIACAO = RESAVAL.NREXECAVALIACAO
                  AND EXEC.NRORG          = RESAVAL.NRORG
                  LEFT JOIN PARCNEGOCIO PA
                   ON PA.NRPARCNEGOCIO = EXEC.NRPARCAVALIADO
                   AND PA.NRORG = EXEC.NRORG
                  JOIN AVALIACAOGERAL AVAL
                  ON AVAL.IDSITUACAOAVALIACAO = 'CONCLUIDA'
                  AND AVAL.NRAVALIACAO        = EXEC.NRAVALIACAO
                  AND AVAL.NRORG              = EXEC.NRORG";
        $sql .= $where;
        $sql .= " GROUP BY PA.NMPRINCIPALPARC, RESAVAL.TXRESPAVALIACAO)
                  GROUP BY NMPRINCIPALPARC";
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute();
        $dataSet = $std->fetchAll();

        return $dataSet;
    }
}