<?php

namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class MunicipioFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
        
    }
    
    public function geraCodigoMunicipio($paramsGetMaxCode){
        $querySelectMaxCode = "SELECT MAX(CDMUNICIPIO) CDMUNICIPIO FROM MUNICIPIO
                                        WHERE NRORG = :NRORG
                                            AND SGESTADO = :SGESTADO
                                            AND CDPAIS   = :CDPAIS";   
                         
        try
        {
            $std = $this->connection->prepare($querySelectMaxCode);
            $std->execute($paramsGetMaxCode);
            $maxCode = $std->fetchAll();
            
        }catch (\Exception $e)
        {
            throw $e;
        }
        if(!empty($maxCode[0])){
            return $maxCode[0]['CDMUNICIPIO'];
        }else{
            return '0000';
        }
    }
    
    
}